/*
 * RSH - Robte si hocičo
 *
 * Ktokoľvek a čokoľvek smie kopírovať, upravovať, zverejňovať,
 * používať, kompilovať, predávať a šíriť toto dielo
 * a všetky jeho časti v akejkoľvek podobe na akékoľvek účely,
 * komerčné a nekomerčné, bez akýchkoľvek obmedzení,
 * bez dodržiavania akýchkoľvek podmienok
 * a akýmikoľvek prostriedkami.
 *
 * Jeder und alles darf kopieren, bearbeiten, veröffentlichen,
 * verwenden, kompilieren, verkaufen und verbreiten dieses Werk
 * und alle seine Teile in irgendeiner Form für irgendeinen Zweck,
 * kommerziell und nichtkommerziell, ohne Beschränkungen,
 * ohne irgendwelche Bedingungen einzuhalten
 * und mit allen Mitteln.
 *
 * Anyone and anything may copy, edit, publish,
 * use, compile, sell and distribute this work
 * and all its parts in any form for any purpose,
 * commercial and non-commercial, without any restrictions,
 * without complying with any conditions
 * and by any means.
 */

#include <windows.h>
#include <stdio.h>

#include "zdroje.h"
#include "yuvp.h"

#define ROZLIISHENIE_720P_SHIIRKA 1280
#define ROZLIISHENIE_720P_VYYSHKA 720

#define ROZLIISHENIE_1080P_SHIIRKA 1920
#define ROZLIISHENIE_1080P_VYYSHKA 1080

static const char g_szClassName[] = "muojaOknoTrieda";

static const int ID_TIMER = 1;

static BITMAPV5HEADER bmh;
static HBITMAP hbm;
static void *pvBits;

static unsigned int shiirka = ROZLIISHENIE_720P_SHIIRKA;
static unsigned int vyyshka = ROZLIISHENIE_720P_VYYSHKA;
static YUV *yuv = NULL;

static char nadpis[MAX_PATH + 100] = "";
static char aktuaalnySuubor[MAX_PATH] = "";

static int pauza = 0;

static UINT menuItemy[] = {ID_SUUBOR_ZATVORITH,
                           ID_SUUBOR_ZNOVUOTVORITH,
                           ID_PREHRAAVANIE_PAUZA,
                           ID_PREHRAAVANIE_IISTH_NA_SNIIMKU};

static void otvorenie(HMENU hmenu)
{
    int i;

    for (i = 0; i < 4; i++)
    {
        EnableMenuItem(hmenu, menuItemy[i], MF_ENABLED);
    }
}

static void zatvorenie(HMENU hmenu)
{
    int i;

    for (i = 0; i < 4; i++)
    {
        EnableMenuItem(hmenu, menuItemy[i], MF_GRAYED);
    }
}


LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    switch (msg) {
        /*case WM_LBUTTONDOWN: {
            char szFileName[MAX_PATH];
            HINSTANCE hInstance = GetModuleHandle(NULL);

            if (GetModuleFileName(hInstance, szFileName, MAX_PATH) == 0)
            {
                MessageBox(NULL, "GetModuleFileName() zlyhalo!",
                           "Chyba!", MB_ICONEXCLAMATION | MB_OK);

                break;
            }

            MessageBox(hwnd, szFileName,
                       "Tento program je", MB_ICONINFORMATION | MB_OK);

            break;
        }*/

        case WM_CREATE: {
            HDC hdc = GetDC(hwnd);

            ZeroMemory(&bmh, sizeof(BITMAPV5HEADER));
            bmh.bV5Size = sizeof(BITMAPV5HEADER);
            bmh.bV5Width = shiirka;
            bmh.bV5Height = -vyyshka;
            bmh.bV5Planes = 1;
            bmh.bV5BitCount = 32;
            bmh.bV5Compression = BI_RGB;

            hbm = CreateDIBSection(hdc, (BITMAPINFO *)&bmh, DIB_RGB_COLORS,
                                   &pvBits, NULL, 0);

            if (hbm == NULL)
            {
                MessageBox(NULL, "!!!!!!!!!!!!!!!!!",
                           "Chyba!", MB_ICONEXCLAMATION | MB_OK);
            }

            ReleaseDC(hwnd, hdc);

            if (SetTimer(hwnd, ID_TIMER, 50, NULL) == 0)
            {
                MessageBox(NULL, "SetTimer()",
                           "Chyba!", MB_ICONEXCLAMATION | MB_OK);
            }

            break;
        }

        case WM_PAINT: {
            PAINTSTRUCT ps;
            HDC hdc = BeginPaint(hwnd, &ps);
            RECT rcClient;

            GetClientRect(hwnd, &rcClient);

            /*{
                char buf[100];
                sprintf(buf, "%li %li\n", rcClient.right, rcClient.bottom);
                MessageBox(NULL, buf,
                           "NIE Chyba!", MB_OK);
            }*/

            GdiFlush();

            memset(pvBits, 255, 1000);

            SetDIBitsToDevice(hdc, 0, 0, rcClient.right, rcClient.bottom,
                              0, 0, 0, rcClient.bottom, pvBits, (BITMAPINFO *)&bmh,
                              DIB_RGB_COLORS);
            GdiFlush();

            EndPaint(hwnd, &ps);

            break;
        }

        case WM_TIMER: {
            HDC hdc = GetDC(hwnd);
            RECT rcClient;

            GetClientRect(hwnd, &rcClient);

            if (yuv && !pauza)
            {
                sprintf(nadpis, "%s - sniimka: %i - ZP (YUV)",
                        aktuaalnySuubor, yuv->nSniimka);
                SetWindowText(hwnd, nadpis);
                yuvpSniimka(yuv, pvBits);
            }

            SetDIBitsToDevice(hdc, 0, 0, rcClient.right, rcClient.bottom,
                              0, 0, 0, rcClient.bottom, pvBits, (BITMAPINFO *)&bmh,
                              DIB_RGB_COLORS);

            ReleaseDC(hwnd, hdc);

            break;
        }

        case WM_COMMAND: {
            switch (LOWORD(wParam)) {
                case ID_SUUBOR_OTVORITH: {
                    OPENFILENAME ofn;
                    char szFileName[MAX_PATH] = "";

                    ZeroMemory(&ofn, sizeof(OPENFILENAME));

                    ofn.lStructSize = sizeof(OPENFILENAME);
                    ofn.hwndOwner = hwnd;
                    ofn.lpstrFilter = ("YUV suubory (*.yuv)\0*.yuv\0"
                                       "Vshetky suubory (*.*)\0*.*\0");
                    ofn.lpstrFile = szFileName;
                    ofn.nMaxFile = MAX_PATH;
                    ofn.Flags = OFN_EXPLORER | OFN_FILEMUSTEXIST;
                    ofn.lpstrDefExt = "yuv";

                    if (GetOpenFileName(&ofn))
                    {
                        yuv = yuvpOtvor(szFileName, shiirka, vyyshka);
                        if (yuv == NULL)
                        {
                            MessageBox(NULL, "yuvpOtvor()",
                                       "Chyba!", MB_ICONEXCLAMATION | MB_OK);
                        }

                        strcpy(aktuaalnySuubor, szFileName);

                        otvorenie(GetMenu(hwnd));
                    }

                    break;
                }

                case ID_SUUBOR_ZATVORITH: {
                    yuvpZatvor(yuv);
                    yuv = NULL;

                    zatvorenie(GetMenu(hwnd));

                    break;
                }

                case ID_SUUBOR_EXIT: {
                    PostMessage(hwnd, WM_CLOSE, 0, 0);

                    break;
                }

                case ID_PREHRAAVANIE_PAUZA: {
                    pauza = !pauza;

                    break;
                }

                case ID_PREHRAAVANIE_IISTH_NA_SNIIMKU: {
                    yuvpPretocsh(yuv, 10000);

                    break;
                }
            }

            break;
        }

        case WM_CLOSE: {
            DestroyWindow(hwnd);

            break;
        }

        case WM_DESTROY: {
            KillTimer(hwnd, ID_TIMER);
            DeleteObject(&hbm);

            if (yuv) yuvpZatvor(yuv);

            PostQuitMessage(0);

            break;
        }

        default : {
            return DefWindowProc(hwnd, msg, wParam, lParam);

            break;
        }
    }

    return (0);
}

#define TEST (WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU)
#define TEST2 WS_OVERLAPPEDWINDOW

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                   LPSTR lpCmdLine, int nCmdShow)
{
    WNDCLASSEX wc;
    HWND hwnd;
    MSG msg;
    BOOL bRet;
    RECT rect;

    wc.cbSize = sizeof(wc);
    wc.style = 0;
    wc.lpfnWndProc = WndProc;
    wc.cbClsExtra = 0;
    wc.cbWndExtra = 0;
    wc.hInstance = hInstance;
    wc.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_MOJAIKONA));
    wc.hCursor = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
    wc.lpszMenuName = MAKEINTRESOURCE(IDR_MOJEMENU);
    wc.lpszClassName = g_szClassName;
    wc.hIconSm = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_MOJAIKONA));

    if(!(RegisterClassEx(&wc)))
    {
        MessageBox(NULL, "Nepodarilo sa zaregistrovath okno!",
                   "Chyba!", MB_ICONEXCLAMATION | MB_OK);

        return (0);
    }

    rect.left = 0;
    rect.top = 0;
    rect.right = 1280;
    rect.bottom = 720;
    /*rect.right = 1920;
    rect.bottom = 1080;*/

    if(!(AdjustWindowRectEx(&rect, TEST | WS_CAPTION,
                            TRUE, WS_EX_CLIENTEDGE)))
    {
        MessageBox(NULL, "AdjustWindowRect!",
                   "Chyba!", MB_ICONEXCLAMATION | MB_OK);

        return (0);
    }

    hwnd = CreateWindowEx(WS_EX_CLIENTEDGE, g_szClassName, "NaDpIs",
                          TEST, CW_USEDEFAULT, CW_USEDEFAULT,
                          rect.right - (rect.left), rect.bottom - (rect.top),
                          NULL, NULL, hInstance, NULL);

    if (hwnd == NULL)
    {
        MessageBox(NULL, "Nepodarilo sa vytvorith okno!",
                   "Chyba!", MB_ICONEXCLAMATION | MB_OK);

        return (0);
    }

    ShowWindow(hwnd, nCmdShow);
    UpdateWindow(hwnd);

    while ((bRet = GetMessage(&msg, NULL, 0, 0)) != 0)
    {
        if (bRet == -1)
        {
            MessageBox(NULL, "GetMessage() vraatilo -1!",
                       "Chyba!", MB_ICONEXCLAMATION | MB_OK);

            return (0);
        }
        else
        {
            TranslateMessage(&msg);
            DispatchMessage(&msg);
        }
    }

    /*yuvpZatvor();*/

    return (msg.wParam);
}
