/*
 * RSH - Robte si hocičo
 *
 * Ktokoľvek a čokoľvek smie kopírovať, upravovať, zverejňovať,
 * používať, kompilovať, predávať a šíriť toto dielo
 * a všetky jeho časti v akejkoľvek podobe na akékoľvek účely,
 * komerčné a nekomerčné, bez akýchkoľvek obmedzení,
 * bez dodržiavania akýchkoľvek podmienok
 * a akýmikoľvek prostriedkami.
 *
 * Jeder und alles darf kopieren, bearbeiten, veröffentlichen,
 * verwenden, kompilieren, verkaufen und verbreiten dieses Werk
 * und alle seine Teile in irgendeiner Form für irgendeinen Zweck,
 * kommerziell und nichtkommerziell, ohne Beschränkungen,
 * ohne irgendwelche Bedingungen einzuhalten
 * und mit allen Mitteln.
 *
 * Anyone and anything may copy, edit, publish,
 * use, compile, sell and distribute this work
 * and all its parts in any form for any purpose,
 * commercial and non-commercial, without any restrictions,
 * without complying with any conditions
 * and by any means.
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include <windows.h>

#include "yuvp.h"

static void zlyhanie(void)
{
    printf("Zlyhanie\n");
    exit(0);
}

YUV *yuvpOtvor(char *meno, unsigned int shiirka, unsigned int vyyshka)
{
    YUV *yuv = malloc(sizeof(YUV));

    if (yuv == NULL) return (NULL);

    yuv->f = fopen(meno, "rb");
    if (yuv->f == NULL) zlyhanie();

    yuv->yuvSniimka = malloc(shiirka * vyyshka * 3);
    if (yuv->yuvSniimka == NULL) zlyhanie();

    yuv->nSniimka = 0;

    yuv->shiirka = shiirka;
    yuv->vyyshka = vyyshka;

    return (yuv);
}

void yuvpZatvor(YUV *yuv)
{
    fclose(yuv->f);
    free(yuv->yuvSniimka);
    free(yuv);
}

static int klamp(int vstup)
{
    if (vstup < 0) return (0);
    if (vstup > 255) return (255);
    return (vstup);
}

void yuvpPretocsh(YUV *yuv, int novaaSniimka)
{
    rewind(yuv->f);
    for (yuv->nSniimka = 0; yuv->nSniimka < novaaSniimka; yuv->nSniimka++)
    {
        fseek(yuv->f, (yuv->shiirka) * (yuv->vyyshka) * 3, SEEK_CUR);
    }
}

int yuvpSniimka(YUV *yuv, void *sniimka)
{
    unsigned int totaal = (yuv->shiirka) * (yuv->vyyshka);
    unsigned int s1, s2, i;
    unsigned char *buf = sniimka;
    unsigned char *yuvSniimka = yuv->yuvSniimka;

    if (feof(yuv->f)) return (1);
    fread(yuvSniimka, (yuv->shiirka) * (yuv->vyyshka) * 3, 1, yuv->f);

    i = 0;

    for (s2 = 0; s2 < (yuv->vyyshka); s2++)
    {
        for (s1 = 0; s1 < (yuv->shiirka); s1++, i += 4)
        {
            int y, u, v;
            int csh, z, m;

            y = yuvSniimka[s2 * (yuv->shiirka) + s1];
            u = yuvSniimka[(s2 / 2) * ((yuv->shiirka) / 2)
                           + (s1 / 2) + totaal];
            v = yuvSniimka[(s2 / 2) * ((yuv->shiirka) / 2)
                           + (s1 / 2) + totaal + totaal / 4];

            /* YUV420 na CshZM. */
            csh = 1.164 * (y - 16) + 1.596 * (v - 128);
            z = 1.164 * (y - 16) - 0.813 * (v - 128) - 0.391 * (u - 128);
            m = 1.164 * (y - 16) + 2.018 * (u - 128);

            /* klamp() nie "& 0xff"! */
            buf[i + 2] = (unsigned char)klamp(csh);
            buf[i + 1] = (unsigned char)klamp(z);
            buf[i + 0] = (unsigned char)klamp(m);
        }
    }

    yuv->nSniimka++;

    return (0);
}
